library   ieee;
use ieee.std_logic_1164.all;

package  pack is
	
	
	procedure calcola( signal x: in integer range -128 to 127; 
				   signal y: in integer range -128 to 127;
				   signal o: in integer range 0 to 3;
				   signal ris: out integer range -32768 to 32767;
				   signal s: out std_logic;
				   signal z: out std_logic);
end pack;


package body pack is
	
	procedure calcola( signal x: in integer range -128 to 127; 
				   signal y: in integer range -128 to 127;
				   signal o: in integer range 0 to 3;
				   signal ris: out integer range -32768 to 32767;
				   signal s: out std_logic;
				   signal z: out std_logic)
 is
 variable tmp: integer range -32768 to 32767;
 begin
	 
	 case o is
		 when 0 => -- somma
		 		tmp := x +y;
		 when 1 => -- differenza
		 		tmp := x-y;
		 when 2 => -- prodotto
		 tmp := x*y;
		 when 3  => --divisione
		 	tmp:= x/y;
	end case;
	
	ris<= tmp;
	if tmp>=0  then s<='0';
	else s<= '1';
	end if;
	if 	tmp = 0 then z<= '1';
	else z<='0';
	end if;
end procedure;
end pack;
