library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity calcolo is
	port (din: in std_logic_vector(7 downto 0);
	clk,nw: in std_logic;
	ris: out std_logic_vector(7 downto 0));
end calcolo;

architecture beh of calcolo is
type stati is (idle, letta, lettb,calcola);
signal st: stati;
signal a,b: std_logic_vector(7 downto 0);  
begin 
process(clk)
begin
	if clk'event and clk='0' then 
		case st is
			when idle => if nw = '1' then st <= letta;
			             else st <= idle;
						 end if;
			when letta => st <= lettb;
			when lettb => st <= calcola;
			--when calcola => st <= idle;
			when others => st <= idle;
		end case;
	end if;
end process;

process(clk)
begin
	if clk'event and clk='0' then 
	 if  st = letta then 
		 a<= din;
	 elsif st = lettb then 
		 b<= din;
	 elsif st = calcola then 
		 ris <= A + B;
     end if;
	end if;
end process;

end beh;


		 
			